﻿using Android.Graphics;
using Android.Graphics.Drawables;
using System.IO;
using Xamarin.Forms;

[assembly: Dependency(typeof(GaugeTestApp.Droid.Dependencies.ImageResizer_Dep))]
namespace GaugeTestApp.Droid.Dependencies
{
    public class ImageResizer_Dep : IImageResizer
    {
        public byte[] ResizeImage(string filename, double width, double height)
        {
            MemoryStream msReturn = new MemoryStream();
            var context = Android.App.Application.Context;
            using (var drawable = Xamarin.Forms.Platform.Android.ResourceManager.GetDrawable(context, filename))
            using (var bitmap = ((BitmapDrawable)drawable).Bitmap)
            {
                var ms = new MemoryStream();
                bitmap.Compress(Bitmap.CompressFormat.Png, 100, ms);
                byte[] imageData = ms.ToArray();
                Bitmap originalImage = BitmapFactory.DecodeByteArray(imageData, 0, imageData.Length);
                Bitmap resizedImage = Bitmap.CreateScaledBitmap(originalImage, (int)width, (int)height, false);
                resizedImage.Compress(Bitmap.CompressFormat.Png, 100, msReturn);
            }

            return msReturn.ToArray();
        }
    }
}
